/****************************************************************************
*
*							  The MegaToolbox
*
*                   Copyright (C) 1993 SciTech Software
*							All rights reserved.
*
* Filename:		$RCSfile: console.h $
* Version:		$Revision: 1.2 $
*
* Language:		ANSI C
* Environment:	IBM PC (MS DOS)
*
* Description:	Header file for console manipulation module.
*
* $Id: console.h 1.2 1993/12/30 14:01:20 kjb release $
*
****************************************************************************/

#ifndef	__CONSOLE_H
#define	__CONSOLE_H

#ifndef	__DEBUG_H
#include "debug.h"
#endif

/*--------------------- Macros and type definitions -----------------------*/

#ifndef __COLORS
#define	__COLORS

enum COLORS {
	BLACK,					/* dark colors	*/
	BLUE,
	GREEN,
	CYAN,
	RED,
	MAGENTA,
	BROWN,
	LIGHTGRAY,
	DARKGRAY,				/* light colors	*/
	LIGHTBLUE,
	LIGHTGREEN,
	LIGHTCYAN,
	LIGHTRED,
	LIGHTMAGENTA,
	YELLOW,
	WHITE
	};
#endif

#define	BLINK	128			/* Blink bit	*/

/* Predefined cursor types */

#define	CURSOR_NORMAL	1
#define	CURSOR_FULL		2

/* Scrolling directions */

#define	SCROLL_UP		1
#define	SCROLL_DOWN		2
#define	SCROLL_LEFT		3
#define	SCROLL_RIGHT	4

/* Macro to build attribute bytes */

#define	CON_makeAttr(f,b)	(char)( (((f) & 0x0F) << 4) | ((b) & 0x0F))

/*---------------------------- Global variables ---------------------------*/

extern	bool	checksnow;
extern	bool	checkCGAsnow;
extern	bool	directvideo;
extern	int		wrapmode;

/*------------------------- Function Prototypes ---------------------------*/

#ifdef	__cplusplus
extern "C" {			/* Use "C" linkage when in C++ mode	*/
#endif

void	CON_init(void);
void	CON_printf(char *format, ...);
void 	CON_puts(char *str);
void 	CON_putc(int c);
void 	CON_writec(int x,int y,int attr,int c);
void	CON_write(int x,int y,int attr,char *str);
void 	CON_clreol(void);
void 	CON_clrscr(void);
void 	CON_gotoxy(int x,int y);
int 	CON_wherex(void);
int	 	CON_wherey(void);
void 	CON_delline(void);
void 	CON_insline(void);
void 	CON_moveText(int left,int top,int right,int bottom,int destleft,
		int desttop);
void 	CON_saveText(int left,int top,int right,int bottom,void *destin);
void 	CON_restoreText(int left,int top,int right,int bottom,
		void *source);
void 	CON_scroll(int direction,int amt);
void 	CON_fillText(int left,int top,int right,int bottom,int attr,
		int ch);
void 	CON_fillAttr(int left,int top,int right,int bottom,int attr);
void 	CON_setWindow(int left,int top,int right,int bottom);
void 	CON_getWindow(int *left,int *top,int *right,int *bottom);
int		CON_maxx(void);
int		CON_maxy(void);
int		CON_getAttr(void);
void 	CON_setAttr(int attr);
void	CON_setBackground(int attr,int ch);
void	CON_getBackground(int *attr,int *ch);
void 	CON_setBackColor(int newcolor);
void 	CON_setForeColor(int newcolor);
void 	CON_setCursor(int type);
void 	CON_cursorOff(void);
void 	CON_restoreCursor(int scans);
int 	CON_getCursor(void);
void	CON_setActivePage(int page);
int		CON_getActivePage(void);
void	CON_setVisualPage(int page);
int		CON_getVisualPage(void);

#ifdef	__cplusplus
}						/* End of "C" linkage for C++	*/
#endif

#endif  /* __CONSOLE_H */
